﻿using System;
using System.Collections.Generic;
using System.IO;

namespace KB4
{
    internal class Bin
    {
        private string BinName = "";
        private List<int> Offsets = new List<int>();
        private Table Tbl = new Table();
        private BinaryReader reader;
        private int NumString;
        private uint Uvar;
        private int Ivar;
        public bool Start;
        public Bin(string filename)
        {
            FileStream fs = new FileStream(filename, FileMode.Open, FileAccess.Read);
            reader = new BinaryReader(fs);
            BinName = filename;
            this.NumString = reader.ReadInt32() / 4;
            reader.BaseStream.Seek(0, SeekOrigin.Begin);
            for (int i = 0; i < this.NumString; i++)
            {
                Offsets.Add(reader.ReadInt32());
            }
            ToXml();
            fs.Close();


        }
        public void ToXml()
        {

            this.ToXml(Path.ChangeExtension(this.BinName, "xml"));
        }
        public void ToXml(string xmlName)
        {
            FileStream fstxt = new FileStream(xmlName, FileMode.Create, FileAccess.Write);
            StreamWriter Xml = new StreamWriter(fstxt);
            int i = 0;
            Xml.Write("TOTAL_STRING:{0,0:d4}\n******************************\n", this.NumString);
            foreach (long offset in this.Offsets)
            {
                this.reader.BaseStream.Seek(offset, SeekOrigin.Begin);
                this.Start = true;
                Xml.WriteLine("[{0,0:d4}]", i);
                while (this.Start)
                {
                    string c = GetChar();
                    Xml.Write(c);
                }
                i++;
            }

            Xml.Flush();
            Xml.Close();

        }
        public string GetChar()
        {
            string ret = "iooio";


            this.Uvar = (uint)this.reader.ReadByte();
            if (Uvar == 0)
            {
                this.Start = false;
                return "\n----------------------------------------\n";
            }
            if (this.Uvar < 200)
            {
                ret = this.Tbl.Index[(uint)(this.Uvar - 1)];

            }

            if (0xee < this.Uvar)
            {
                string ctrlcode;
                switch (this.Uvar)
                {
                    case 0xef:
                        ctrlcode = "<EF/>";
                        break;
                    case 0xf0:
                        ctrlcode = "<choice/>";
                        break;
                    case 0xf1:
                        ctrlcode = "<F1/>";
                        break;
                    case 0xf2:
                        ctrlcode = "<F2/>";
                        break;
                    case 0xf3:
                        ctrlcode = "<F3/>";
                        break;
                    case 0xf4:
                        ctrlcode = "<F4/>";
                        //ctrlcode = String.Format("<F4{0,0:X2}/>", this.reader.ReadByte());
                        break;
                    case 0xf5:
                        ctrlcode = String.Format("<F5{0,0:X2}/>", this.reader.ReadByte());
                        break;
                    case 0xf7:
                        ctrlcode = "<F7/>";
                        break;
                    case 0xf8:
                        ctrlcode = "<F8/>";
                        break;
                    case 0xfb:
                        ctrlcode = "<FB/>";
                        break;
                    case 0xfc:
                        ctrlcode = " ";
                        break;
                    case 0xfd:
                        ctrlcode = "\t";
                        break;
                    case 0xfe:
                        ctrlcode = "\n";
                        break;
                    case 0xff:
                        ctrlcode = "\n<nextpage/>\n";
                        break;
                    default:
                        ctrlcode = "<unk>";
                        Console.WriteLine("{0,0:X2}", this.Uvar);
                        Console.ReadLine();
                        break;

                }
                return ctrlcode;
            }
            
            if (199 < this.Uvar)
            {
                this.Ivar = (int)this.reader.ReadByte();
                uint val = (this.Uvar * 0x100 + (uint)(byte)(this.Ivar)) - 51000;
                try
                {
                    ret = this.Tbl.Index[(uint)(val - 1)];
                }
                catch (Exception)
                {

                    ret = String.Format("<{0,0:X2}{1,0:X2}/>", this.Uvar, this.Ivar);//actually blank font/space

                }
               

              


            }
            return ret;
        }

    }
}