﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Text;

namespace KB4
{
    class Xml
    {

        private StreamReader reader;
        private Table Tbl = new Table();
        private int Numstring;
        private string XmlName;
        private string BinName;

        public Xml(string xmlName)
        {
            XmlName = xmlName;
            Tbl.Rev();
            FileStream fileStream = new FileStream(XmlName, FileMode.Open, FileAccess.Read);
            BinName = Path.ChangeExtension(xmlName, ".bin");
            this.reader = new StreamReader(fileStream, Encoding.GetEncoding("utf-8"));
            ToBIn();
            fileStream.Close();

        }
        public int ToBIn()
        {

            FileStream fileStream = new FileStream(this.BinName, FileMode.Create, FileAccess.Write);
            var fileWriter = new BinaryWriter(fileStream);
            int indexString;
            byte[] term = new byte[1];
            try
            {
                this.Numstring = int.Parse(this.reader.ReadLine().Substring(13, 4));

            }
            catch (FormatException)
            {
                Console.WriteLine("Broken index string\n{0}", XmlName);
                Environment.Exit(1);

            }
            this.reader.ReadLine();
           Console.WriteLine(this.Numstring);

            int ptRef = this.Numstring * 4;
            var memoryStream = new MemoryStream();
            var writer = new BinaryWriter(memoryStream);
            int offsets;
            for (int j = 0; j < this.Numstring; j++)
            {
                offsets = (int)writer.BaseStream.Position+ptRef;
                try
                {
                    indexString = int.Parse(this.reader.ReadLine().Substring(1, 4));
                    if (indexString != j)
                    {
                        Console.WriteLine("Broken index string!!\n{0}\nIndex:{1}", XmlName, j);

                        Environment.Exit(1);
                    }

                }
                catch (FormatException)
                {
                    Console.WriteLine("Broken index string!!\n{0}\nIndex:{1}", XmlName, j);

                    Environment.Exit(1);
                }
                catch (NullReferenceException)
                {
                    Console.WriteLine("Broken index string!!\n{0}\nIndex:{1}", XmlName, j);

                    Environment.Exit(1);
                }
                string text = "";
                while (true)
                {
                    string line = this.reader.ReadLine();

                    if (line.Length > 10)
                    {
                        if (line.Substring(0, 10) == "----------")
                        {
                            text = text.Substring(0, text.Length - 1);
                            break;
                        }
                    }
                    text += line + "\n";
                }
                //Console.WriteLine(text);
                fileWriter.Write(offsets);
                writer.Write(EncodeString(text,text.Length));
                writer.Write(term);





            }
            fileWriter.Write(memoryStream.ToArray());
            fileWriter.Flush();
            fileWriter.Close();
            writer.Close();


            return 0;

        }
        private byte[] EncodeString(string decodedString, int lenString)
        {
            decodedString += "---------------------------------";
            char[] array = decodedString.ToCharArray();
            List<string> s = new List<string>();
            MemoryStream memory = new MemoryStream();
            BinaryWriter writer = new BinaryWriter(memory);
            for (int i = 0; i < lenString; i++)
            {
                if
                (
                   array[i] == '<' &&
                   array[i + 3] == '/' &&
                   array[i + 4] == '>'
                )
                {
                    writer.Write((byte)int.Parse(new string(new char[] {array[i + 1], array[i + 2], }),System.Globalization.NumberStyles.HexNumber));

                    i += 4;
                }
                else if
                (
                   array[i] == '<' &&
                   array[i + 5] == '/' &&
                   array[i + 6] == '>'


                )
                {
                    writer.Write((byte)int.Parse(new string(new char[] { array[i + 1], array[i + 2], }), System.Globalization.NumberStyles.HexNumber));
                    writer.Write((byte)int.Parse(new string(new char[] { array[i + 3], array[i + 4], }), System.Globalization.NumberStyles.HexNumber));



                    i += 6;


                }
                else if
                (
                   array[i] == '<' &&
                   array[i + 1] == 'c' &&
                   array[i + 2] == 'h' &&
                   array[i + 3] == 'o' &&
                   array[i + 4] == 'i' &&
                   array[i + 5] == 'c' &&
                   array[i + 6] == 'e' &&
                   array[i + 7] == '/' &&
                   array[i + 8] == '>' 
                   


                )
                {
                    writer.Write((byte) 0xf0);

                    i += 8;


                }


                else if
               (
                   array[i] == '\n' &&
                   array[i + 1] == '<' &&
                   array[i + 2] == 'n' &&
                   array[i + 3] == 'e' &&
                   array[i + 4] == 'x' &&
                   array[i + 5] == 't' &&
                   array[i + 6] == 'p' &&
                   array[i + 7] == 'a' &&
                   array[i + 8] == 'g' &&
                   array[i + 9] == 'e' &&
                   array[i + 10] == '/' &&
                   array[i + 11] == '>' &&
                   array[i + 12] == '\n'


               )
                {

                    writer.Write((byte)0xff);
                    i += 12;


                }
                else if(array[i] == ' ' )
                {
                    writer.Write((byte)0xfc);
                }
                else if (array[i] == '\t')
                {
                    writer.Write((byte)0xfd);
                }
                else if (array[i] == '\n')
                {
                    writer.Write((byte)0xfe);
                }
                else
                {
                    int val =-1;
                    try
                    {
                        val = (ushort)Tbl.IndexRev[array[i].ToString()] + 1;

                    }
                    catch (Exception)
                    {
                        Console.WriteLine("Undefined char table!!\n{0}", array[i]);
                        Environment.Exit(1);

                    }
                    
                    if(val < 200)
                    {
                        writer.Write((byte)val);
                    }
                    else
                    {

                        val += 51000;
                        writer.Write((byte)(val / 256 & (int)byte.MaxValue));
                        writer.Write((byte)(val & (byte)byte.MaxValue));
                        
                    }

                }

            }
            return memory.ToArray();
        }








        }
}
