from func import *
from ctypes import *
import hashlib, struct, os, io
lzss = CDLL(os.path.abspath("lzss.dll"))
def LzssCompress(decompressedFile):
    com = bytes(len(decompressedFile))
    k = lzss.lzss_compress(decompressedFile, len(decompressedFile), com, len(com))
    com = com[:k]
    return struct.pack("<I", len(decompressedFile)) + com
txtToc = open("LZS-PAC.txt", "r")
txtFile = open("FILE-LIST.txt", "r")
class BIN:
    def __init__(self, data, name):
        self.nameBin = name
        self.outfolder = name[:-4]
        self.data = Br(io.BytesIO(data))
        self.data.seek(4)
        self.tocSize = self.data.readUint32()
        self.totalFile = (self.tocSize // 0x40)
        self.data.seek(4)
        self.offsets = []
        self.sizes = []
        self.names = []
        self.data.seek(0)
        for i in range(self.totalFile):
            id = self.data.read(4)
            self.offsets.append(self.data.readUint32())
            self.sizes.append(self.data.readUint32())
            self.data.read(4)
            self.names.append(self.data.readString())
            self.data.rpad(0x40)
    def repack(self):
        toc = self.data
        toc.seek(0)
        files = Br(io.BytesIO())
        for name in self.names:
            if "Mes.bin" in name:
                os.system("KB4.exe -xml {}".format(self.outfolder + "/" + name.replace(".bin",".xml")))
        
        
            data = open(self.outfolder +  "/" + name, "rb").read()
            off = files.tell() + self.tocSize
            files.write(data)
            size = len(data)
            toc.read(4)
            toc.writeUint32(off)
            toc.writeUint32(size)
            toc.read(0x34)
            files.wpad(0x20)
        return toc.getBytes(0,self.tocSize) + files.getdata()
def repackAll():
    list = open("LZS-PAC.txt","r")
    pacList = []
    for line in list:
        pacList.append(line)
    for s in sorted(pacList,reverse=True):
        pacName = s[:-1]
        pac = BIN(open(pacName, "rb").read(), pacName)
        newPac = pac.repack()
        fileSave(newPac, pacName)
        print("insert: "+pacName)
    toc = Br(io.BytesIO(open("PAC0.BIN", "rb").read()))
    toc.seek(0x100)
    File1 = Br(open("NEW/PAC1.BIN", "wb"))
    File2 = Br(open("NEW/PAC2.BIN", "wb"))
    list = open("FILE-LIST.txt", "r")
    for line in list:
        type,compressed,paddingType,fileName = line[:-1].split(",")
        type, compressed, paddingType =int(type, 16),int(compressed, 16),int(paddingType, 16)
        print("insert: "+fileName)
        if type == 0:
            toc.read(0x40)
        elif type == 1:
            newData = open(fileName,"rb").read()
            if compressed:
               newData = LzssCompress(newData)
            location = toc.readUint16()
            type = toc.readUint16()  # 0 = folder, 1 = file
            nameOff = toc.readUint32()
            nameSize = toc.readUint32()
            newFileSize = len(newData)
            if location == 1:
                newOffset = File1.tell()
                File1.write(newData)
                toc.writeUint32(newOffset)
                toc.writeUint32(newFileSize)
                padding = File1.wpad(0x800,struct.pack("B",paddingType))
                null = toc.readUint32()
                folderLoc = toc.readUint32()
                toc.writeUint32(padding+newFileSize)
            elif location == 2:
                newOffset = File2.tell()
                File2.write(newData)
                toc.writeUint32(newOffset)
                toc.writeUint32(newFileSize)
                padding = File2.wpad(0x800,struct.pack("B",paddingType))
                null = toc.readUint32()
                folderLoc = toc.readUint32()
                toc.writeUint32(padding + newFileSize)
            toc.write(hashlib.sha256(newData).digest())
    fileSave(toc.getdata(),"NEW/PAC0.BIN")

repackAll()
