from func import *
from ctypes import *
import struct, os,io
lzss = CDLL(os.path.abspath("lzss.dll"))
txtToc = open("LZS-PAC.txt", "w")
meslist = open("mes.txt", "w")

txtFile = open("FILE-LIST.txt", "w")
def LzssDecompress(compressedFile):
    decSize = struct.unpack("<I", compressedFile[:4])[0]
    dec = bytes(decSize)
    lzss.unlzss(compressedFile[4:], len(compressedFile) - 4, dec, decSize)
    return dec
class BIN:
    def __init__(self, data, name):
        self.nameBin = name
        self.outfolder = name[:-4]
        self.data = Br(io.BytesIO(data))
        self.data.seek(4)
        self.tocSize = self.data.readUint32()
        self.totalFile = (self.tocSize // 0x40)
        self.data.seek(4)
        self.offsets = []
        self.sizes = []
        self.names = []
        self.data.seek(0)
        for i in range(self.totalFile):
            id = self.data.read(4)
            self.offsets.append(self.data.readUint32())
            self.sizes.append(self.data.readUint32())
            self.data.read(4)
            self.names.append(self.data.readString())
            self.data.rpad(0x40)
    def unpack(self):
        txtToc.write(self.nameBin + "\n")
        for off, size, name in zip(self.offsets, self.sizes, self.names):
            print("extract: "+self.outfolder + "/" + name)
            data = self.data.getBytes(off, size)
            if name[-3:] == "pac":
                pac = BIN(data,self.outfolder + "/" + name)
                pac.unpack()
            fileSave(data, self.outfolder + "/" + name)
            if "Mes.bin" in name:
                os.system("KB4.exe -bin {}".format(self.outfolder + "/" + name))
                meslist.write(self.outfolder + "/" + name +"\n")
        fileSave(self.data.getdata(), self.nameBin)
def unpackAll():
    folders = ["EX/",
               "EX/charadata",
               "EX/data",
               "EX/data/obj",
               "EX/eventdata",
               "EX/icon",
               "EX/sound", ]
    toc = Br(open("PAC0.BIN","rb"))
    File1 = Br(open("PAC1.BIN","rb"))
    File2 =Br(open("PAC2.BIN","rb"))
    Names = Br(io.BytesIO(toc.getBytes(0x10F80,0x4938)))
    numFolder = toc.readUint32()
    numNames = toc.readUint32()
    namesSize = toc.readUint32()
    unk0 =toc.readUint32()
    toc.read(0x10)
    toc.seek(0x100)
    for i in range(numNames):
        location = toc.readUint16()
        type = toc.readUint16()  #0 = folder, 1 = file
        nameOff = toc.readUint32()
        nameSize = toc.readUint32()
        fileOffset = toc.readUint32()
        fileSize = toc.readUint32()
        null = toc.readUint32()
        folderLoc = toc.readUint32()
        fileSizeAndPdding =toc.readUint32()
        fileName = Names.getUtf8(nameOff)
        SHA256 = toc.read(0x20)
        filedata = 0
        padding = 0
        compressed = 0
        if type == 0:
            pass
        else:
            if location == 1:
                filedata = File1.getBytes(fileOffset, fileSize)
                padding = struct.unpack("B", File1.getBytes(fileOffset + fileSize, 1))[0]
            elif location == 2:
                filedata = File2.getBytes(fileOffset, fileSize)
                padding = struct.unpack("B", File2.getBytes(fileOffset + fileSize, 1))[0]
            if fileName[-3:] == "lzs":
                compressed = 1
                filedata = LzssDecompress(filedata)
                bin = BIN(filedata, folders[folderLoc] + "/" + fileName)
                bin.unpack()
            elif fileName[-3:] == "pac":
                bin = BIN(filedata, folders[folderLoc] + "/" + fileName)
                bin.unpack()
            fileSave(filedata, folders[folderLoc] + "/" + fileName)
        txtFile.write("{0:02d},{1:02X},{2:02X},{3}\n".format(type,compressed,padding,folders[folderLoc] + "/" + fileName))
        print("extract: "+folders[folderLoc] + "/" + fileName)

unpackAll()