import os, struct
class Br:
    def __init__(self, data):
        self.data = data
    def readUint8(self):
        return struct.unpack("B",self.data.read(1))[0]
    def readUint16(self):
        return struct.unpack("H",self.data.read(2))[0]
    def readUint32(self):
        return struct.unpack("I",self.data.read(4))[0]
    def writeUint32(self, val):
        self.data.write(struct.pack("I",val))
    def writeUint16(self, val):
        self.data.write(struct.pack("H",val))
    def writeUint8(self, val):
        self.data.write(struct.pack("B",val))
    def wpad(self, num,pad =b"\x00"):
        padding = num - (self.data.tell() % num or num)
        if padding:
            self.data.write(pad * padding)
        return padding
    def rpad(self, num):
        padding = num - (self.data.tell() % num or num)
        self.data.read(padding)
        return 0
    def getUtf8(self, offset):
        base = self.data.tell()
        self.data.seek(offset, 0)
        chars = b""
        while True:
            c = self.data.read(1)
            if c == b"\x00":
                self.data.seek(base, 0)
                return chars.decode('utf-8')
            chars += c

    def getdata(self):
        self.data.seek(0, 0)
        return self.data.read()
    def getBytes(self, pos, size):
        base = self.data.tell()
        self.data.seek(pos, 0)
        data = self.data.read(size)
        self.data.seek(base, 0)
        return data
    def readString(self):
        chars = b""
        while True:
            c = self.data.read(1)
            if c == b"\x00":

                return chars.decode('utf-8')
            chars += c

    def seek(self, offset, origin=0):
        self.data.seek(offset, origin)
        return ""
    def tell(self):
        data = self.data.tell()
        return data
    def read(self, x=False):
        if x:
            output = self.data.read(x)
        else:
            output = self.data.read()
        return output
    def write(self, indata):
        self.data.write(indata)
    def close(self):
        self.data.close()
def fileSave(data, name):
    os.makedirs(os.path.dirname(name), exist_ok=True)
    output = open(name, "wb")
    output.write(data)
